#include <iostream>
#include <set>
#include <algorithm>
#include <climits>
using namespace std;


bool debug=0;

int translate(const vector<int>& state) /** must contain only 0, 1... state.size()-1*/{
    int ans=0;
    for(int i=0; i<state.size(); i++)
        ans+=state[i]*pow(state.size(), i);
    return ans;
}
int maxres(int n){ ///max number got this way
    int ans=0;
    for(int i=0; i<n; i++)
        ans+=i*pow(n, i);
    return ans;
}
struct combo{
    int val, ord;
    combo(int val, int ord): val(val), ord(ord){}
    bool operator< (const combo& other) const{
        return val<other.val;
    }
};
void useorder(vector<int>& from){ ///ordered vector to this number
    vector<combo>made;
    for(int i=0; i<from.size(); i++)
        made.emplace_back(from[i], i);
    sort(made.begin(), made.end());
    for(int i=0; i<made.size(); i++)
        from[ made[i].ord ] = i;
}
bool compress(vector<int>& from){ ///if number contains 01 or 10, return true and change vector. else return false

  if (debug){ cout<<"TRY TO COMPRESS ";
   for(int&a:from)
    cout<<a<<" ";
   cout<<endl;
  }

    int last=from[0];
    bool bad=1;
    for(int i=1; i<from.size() && bad; i++){
        if (last+from[i]==1)
            bad=0;
        last=from[i];
    }
    if (bad){

       if(debug) cout<<"BAD"<<endl;


        return 0;
    }

if(debug)
    cout<<"GOOD"<<endl;

    vector<int>ans(from.size()-1);
    int j=0;
    for(int i=0; i<from.size(); i++)
        if(from[i]!=0){
            ans[j]=from[i]-1;
            j++;
        }

    from=ans;

    return 1;
}

#include <assert.h>

vector<int> store;
set <vector<int> > root;
vector<int> store2;
vector<int> metastore;
set <vector<int> > root2;

void mrec(vector<int>state, int steps){ ///fill root2
    if (store[translate(state)]!=steps)
        return;
    vector<int>buf=state;
    if (compress(buf) && store2[translate(buf)]>store[translate(state)]+1){


        assert(buf.size()==state.size()-1);

        root2.insert(buf);
        store2[translate(buf)]=store[translate(state)]+1;
    }
    store[translate(state)]=-1;
    for(int i=0; i<state.size()-1; i++){
        swap(state[i], state[i+1]);
        mrec(state, steps+1);
        swap(state[i], state[i+1]);
    }

}
void rec(vector<int>state, int steps){
    if (store[translate(state)]>steps){

    if(debug){
        cout<<steps<<" steps to reach "<<state.size()<<"-"<<translate(state)<<" (";
        for(int i=0; i<state.size()-1; i++)
            cout<<state[i]<<" ";
        cout<<state[state.size()-1]<<")"<<endl;
    }

        store[translate(state)]=steps;
    }
    else
        return;
    for(int i=0; i<state.size()-1; i++){
        swap(state[i], state[i+1]);
        rec(state, steps+1);
        swap(state[i], state[i+1]);
    }
}

void firstlaunch(vector<int>&state){
    root.insert(state);
    store=vector<int>(maxres(state.size())+1, INT_MAX);
    rec(state, 0);
    metastore.resize(store.size(), 0);
}

bool launch(){

   if(debug)
    cout<<"LAAAAA"<<endl;

    auto iter=root.begin();
    if (iter->size()==1)
        return 0;
    store2=vector<int>(maxres(iter->size()-1)+1, INT_MAX);
    root2=set<vector <int> >();
    for(;iter!=root.end();iter++)
        mrec(*iter, metastore[translate(*iter)]);
    ///fill root2
    root=root2;
    iter=root.begin();
    metastore=store2;
    store=vector<int>(maxres(iter->size())+1, INT_MAX);
    for(;iter!=root.end();iter++){

        if(debug)
            cout<<"LAUNCHED FROM "<<translate(*iter)<<endl;

        rec(*iter, metastore[translate(*iter)]);

    }
    return 1;
}





int main(){
    vector<int>a(4);
    for(int& b:a)
        cin>>b;
    useorder(a);
    firstlaunch(a);
    while(launch());
    cout<<store[0];
}

